# .NET Core 2.1.29 Update - August 10, 2021

The .NET 2.1.29, .NET SDK 2.1.817 and [.NET SDK 2.1.525](2.1.525.md) releases are available for download. The latest 2.1 release is always listed at [.NET 2.1 Releases](../README.md).

## Downloads

|           | SDK Installer<sup>1</sup>                        | SDK Binaries<sup>1</sup>                 | Runtime Installer                                        | Runtime Binaries                                 | ASP.NET Core Runtime           |
| --------- | :------------------------------------------:     | :----------------------:                 | :---------------------------:                            | :-------------------------:                      | :-----------------:            |
| Windows   | [x86][dotnet-sdk-win-x86.exe] \| [x64][dotnet-sdk-win-x64.exe] | [x86][dotnet-sdk-win-x86.zip] \| [x64][dotnet-sdk-win-x64.zip] | [x86][dotnet-runtime-win-x86.exe] \| [x64][dotnet-runtime-win-x64.exe] | [x86][dotnet-runtime-win-x86.zip] \| [x64][dotnet-runtime-win-x64.zip] \| [ARM][dotnet-runtime-win-arm.zip] | [x86][aspnetcore-runtime-win-x86.exe] \| [x64][aspnetcore-runtime-win-x64.exe] \| <br> [Hosting Bundle][dotnet-hosting-win.exe]<sup>2</sup> |
| macOS     | [x64][dotnet-sdk-osx-x64.pkg]  | [x64][dotnet-sdk-osx-x64.tar.gz]     | [x64][dotnet-runtime-osx-x64.pkg] | [x64][dotnet-runtime-osx-x64.tar.gz] | [x64][aspnetcore-runtime-osx-x64.tar.gz]<sup>1</sup>
| Linux     | [See installation steps][linux-install]   | [x64][dotnet-sdk-linux-x64.tar.gz] \| [ARM][dotnet-sdk-linux-arm.tar.gz] \| [ARM64][dotnet-sdk-linux-arm64.tar.gz] \| [x64 Alpine][dotnet-sdk-linux-musl-x64.tar.gz] | - | [x64][dotnet-runtime-linux-x64.tar.gz] \| [ARM][dotnet-runtime-linux-arm.tar.gz] \| [ARM64][dotnet-runtime-linux-arm64.tar.gz] \| [x64 Alpine][dotnet-runtime-linux-musl-x64.tar.gz] | [x64][aspnetcore-runtime-linux-x64.tar.gz]<sup>1</sup>  \| [ARM][aspnetcore-runtime-linux-arm.tar.gz]<sup>1</sup> \| [x64 Alpine][aspnetcore-runtime-linux-musl-x64.tar.gz]<sup>1</sup> |
| Checksums | [SDK][checksums-sdk]                             | -                                        | [Runtime][checksums-runtime]                             | - | - |

</br>
1. Includes the .NET Core and ASP.NET Core Runtimes.
</br>2. For hosting stand-alone apps on Windows Servers. Includes the ASP.NET Core Module for IIS and can be installed separately on servers without installing .NET Core runtime.

</br>

The .NET SDK includes a matching updated .NET Runtime. Downloading the Runtime or ASP.NET Core packages is not needed when installing the SDK.

You can check your .NET SDK version by running the following command. The example version shown is for this release.

```console
$ dotnet --version
2.1.817
```

Visit [.NET Documentation](https://docs.microsoft.com/dotnet/core/) to learn about .NET, for building many different types of applications.

## Docker Images

The [.NET Core Docker images](https://hub.docker.com/_/microsoft-dotnet) have been updated for this release. The [.NET Docker samples](https://github.com/dotnet/dotnet-docker/blob/main/samples/README.md) show various ways to use .NET and Docker together.

The following repos have been updated:

* [dotnet/sdk](https://hub.docker.com/_/microsoft-dotnet-sdk/): .NET Core SDK
* [dotnet/aspnet](https://hub.docker.com/_/microsoft-dotnet-aspnet/): ASP.NET Core Runtime
* [dotnet/runtime](https://hub.docker.com/_/microsoft-dotnet-runtime/): .NET Core Runtime
* [dotnet/runtime-deps](https://hub.docker.com/_/microsoft-dotnet-runtime-deps/): .NET Core Runtime Dependencies


## Visual Studio Compatibility

This update for .NET Core 2.1 includes multiple SDK builds. If you are a Visual Studio 2019, Visual Studio 2017 or Visual Studio for Mac user, there are MSBuild version requirements that are satisfied by specific, matching .NET Core SDK versions. See the following table to select the correct download.

| OS | Development Environment | .NET Core SDK |
| :-- | :-- | :--: |
| Windows | Visual Studio 2017 | [2.1.817](#downloads) |
| macOS | Visual Studio for Mac | [Visual Studio for Mac .NET Core Support](https://docs.microsoft.com/visualstudio/mac/net-core-support) |

[.NET Core 2.1 will reach end of support on August 21, 2021](https://devblogs.microsoft.com/dotnet/net-core-2-1-will-reach-end-of-support-on-august-21-2021/). After this date, Microsoft will no longer provide technical support and updates (which includes security fixes) for this version. You'll need to update the version of .NET Core you're using to supported version (.NET Core 3.1 or .NET 5.0) before this date in order to continue to recieve updates. 

## Notable Changes

.NET Core 2.1.29 release carries both security and non-security fixes.

# Microsoft Security Advisory CVE-2021-34485 | .NET Core Information Disclosure Vulnerability

## <a name="executive-summary"></a>Executive summary

Microsoft is releasing this security advisory to provide information about a vulnerability in .NET 5.0, .NET Core 3.1 and .NET Core 2.1. This advisory also provides guidance on what developers can do to update their applications to remove this vulnerability.

An information disclosure vulnerability exists in .NET 5.0, .NET Core 3.1 and .NET Core 2.1 when dumps created by the tool to collect crash dumps and dumps on demand are created with global read permissions on Linux and macOS.

# Microsoft Security Advisory CVE-2021-26423 | .NET Core Denial of Service Vulnerability

## <a name="executive-summary"></a>Executive summary

Microsoft is releasing this security advisory to provide information about a vulnerability in .NET 5.0, .NET Core 3.1 and .NET Core 2.1. This advisory also provides guidance on what developers can do to update their applications to remove this vulnerability.

A denial of service vulnerability exists in .NET 5.0, .NET Core 3.1 and .NET Core 2.1 where .NET (Core) server applications providing WebSocket endpoints could be tricked into endlessly looping while trying to read a single WebSocket frame. 

# Microsoft Security Advisory CVE-2021-34532 | ASP.NET Core Information Disclosure Vulnerability

## <a name="executive-summary"></a>Executive summary

Microsoft is releasing this security advisory to provide information about a vulnerability in .NET 5.0, .NET Core 3.1 and .NET Core 2.1. This advisory also provides guidance on what developers can do to update their applications to remove this vulnerability.

An information disclosure vulnerability exists in .NET 5.0, .NET Core 3.1 and .NET Core 2.1 where an JWT token is logged if it cannot be parsed.

* [Blog Roundup][dotnet-blog]
* [Known issues](../2.1-known-issues.md)

# Behavioral change in Asp.Net 2.1 Installers

## Summary

Asp.Net Core 2.1.29 will now install side-by-side with Asp.Net 2.1.6 or earlier. It will still remove previously installed versions of Asp.Net that are 2.1.7 or newer. Users runnning the 2.1.29 Asp.Net Installer or 2.1.29 Hosting Bundle should manually uninstall any local versions of the Asp.Net runtime that are 2.1.6 or earlier.

## Feedback

Your feedback is important and appreciated. We've created an issue at [dotnet/core #6553](https://github.com/dotnet/core/issues/6553) for your questions and comments.

## Packages updated in this release:

Package name | Version
:----------- | :------------------
microsoft.aspnetcore.all | 2.1.29.nupkg
microsoft.aspnetcore.app | 2.1.29.nupkg
microsoft.dotnet.web.client.itemtemplates | 2.1.29.nupkg
microsoft.dotnet.web.itemtemplates | 2.1.29.nupkg
microsoft.dotnet.web.projecttemplates.2.1 | 2.1.29.nupkg
microsoft.dotnet.web.spa.projecttemplates.2.1 | 2.1.29.nupkg
microsoft.netcore.app | 2.1.29.nupkg
microsoft.netcore.dotnetapphost | 2.1.29.nupkg
microsoft.netcore.dotnethost | 2.1.29.nupkg
microsoft.netcore.dotnethostpolicy | 2.1.29.nupkg
microsoft.netcore.dotnethostresolver | 2.1.29.nupkg
runtime.linux-arm.microsoft.netcore.app | 2.1.29.nupkg
runtime.linux-arm.microsoft.netcore.dotnetapphost | 2.1.29.nupkg
runtime.linux-arm.microsoft.netcore.dotnethost | 2.1.29.nupkg
runtime.linux-arm.microsoft.netcore.dotnethostpolicy | 2.1.29.nupkg
runtime.linux-arm.microsoft.netcore.dotnethostresolver | 2.1.29.nupkg
runtime.linux-arm64.microsoft.netcore.app | 2.1.29.nupkg
runtime.linux-arm64.microsoft.netcore.dotnetapphost | 2.1.29.nupkg
runtime.linux-arm64.microsoft.netcore.dotnethost | 2.1.29.nupkg
runtime.linux-arm64.microsoft.netcore.dotnethostpolicy | 2.1.29.nupkg
runtime.linux-arm64.microsoft.netcore.dotnethostresolver | 2.1.29.nupkg
runtime.linux-musl-x64.microsoft.netcore.app | 2.1.29.nupkg
runtime.linux-musl-x64.microsoft.netcore.dotnetapphost | 2.1.29.nupkg
runtime.linux-musl-x64.microsoft.netcore.dotnethost | 2.1.29.nupkg
runtime.linux-musl-x64.microsoft.netcore.dotnethostpolicy | 2.1.29.nupkg
runtime.linux-musl-x64.microsoft.netcore.dotnethostresolver | 2.1.29.nupkg
runtime.linux-x64.microsoft.netcore.app | 2.1.29.nupkg
runtime.linux-x64.microsoft.netcore.dotnetapphost | 2.1.29.nupkg
runtime.linux-x64.microsoft.netcore.dotnethost | 2.1.29.nupkg
runtime.linux-x64.microsoft.netcore.dotnethostpolicy | 2.1.29.nupkg
runtime.linux-x64.microsoft.netcore.dotnethostresolver | 2.1.29.nupkg
runtime.osx-x64.microsoft.netcore.app | 2.1.29.nupkg
runtime.osx-x64.microsoft.netcore.dotnetapphost | 2.1.29.nupkg
runtime.osx-x64.microsoft.netcore.dotnethost | 2.1.29.nupkg
runtime.osx-x64.microsoft.netcore.dotnethostpolicy | 2.1.29.nupkg
runtime.osx-x64.microsoft.netcore.dotnethostresolver | 2.1.29.nupkg
runtime.rhel.6-x64.microsoft.netcore.app | 2.1.29.nupkg
runtime.rhel.6-x64.microsoft.netcore.dotnetapphost | 2.1.29.nupkg
runtime.rhel.6-x64.microsoft.netcore.dotnethost | 2.1.29.nupkg
runtime.rhel.6-x64.microsoft.netcore.dotnethostpolicy | 2.1.29.nupkg
runtime.rhel.6-x64.microsoft.netcore.dotnethostresolver | 2.1.29.nupkg
runtime.win-arm.microsoft.netcore.app | 2.1.29.nupkg
runtime.win-arm.microsoft.netcore.dotnetapphost | 2.1.29.nupkg
runtime.win-arm.microsoft.netcore.dotnethost | 2.1.29.nupkg
runtime.win-arm.microsoft.netcore.dotnethostpolicy | 2.1.29.nupkg
runtime.win-arm.microsoft.netcore.dotnethostresolver | 2.1.29.nupkg
runtime.win-arm64.microsoft.netcore.app | 2.1.29.nupkg
runtime.win-arm64.microsoft.netcore.dotnetapphost | 2.1.29.nupkg
runtime.win-arm64.microsoft.netcore.dotnethost | 2.1.29.nupkg
runtime.win-arm64.microsoft.netcore.dotnethostpolicy | 2.1.29.nupkg
runtime.win-arm64.microsoft.netcore.dotnethostresolver | 2.1.29.nupkg
runtime.win-x64.microsoft.netcore.app | 2.1.29.nupkg
runtime.win-x64.microsoft.netcore.dotnetapphost | 2.1.29.nupkg
runtime.win-x64.microsoft.netcore.dotnethost | 2.1.29.nupkg
runtime.win-x64.microsoft.netcore.dotnethostpolicy | 2.1.29.nupkg
runtime.win-x64.microsoft.netcore.dotnethostresolver | 2.1.29.nupkg
runtime.win-x86.microsoft.netcore.app | 2.1.29.nupkg
runtime.win-x86.microsoft.netcore.dotnetapphost | 2.1.29.nupkg
runtime.win-x86.microsoft.netcore.dotnethost | 2.1.29.nupkg
runtime.win-x86.microsoft.netcore.dotnethostpolicy | 2.1.29.nupkg
runtime.win-x86.microsoft.netcore.dotnethostresolver | 2.1.29.nupkg
vs.redist.common.netcore.hostfxr.x64.2.1 | 2.1.29-servicing-30323-02.nupkg
vs.redist.common.netcore.hostfxr.x64.2.1 | 2.1.29-servicing-30323-03.nupkg
vs.redist.common.netcore.hostfxr.x86.2.1 | 2.1.29-servicing-30323-02.nupkg
vs.redist.common.netcore.hostfxr.x86.2.1 | 2.1.29-servicing-30323-03.nupkg
vs.redist.common.netcore.sharedframework.x64.2.1 | 2.1.29-servicing-30323-02.nupkg
vs.redist.common.netcore.sharedframework.x64.2.1 | 2.1.29-servicing-30323-03.nupkg
vs.redist.common.netcore.sharedframework.x86.2.1 | 2.1.29-servicing-30323-02.nupkg
vs.redist.common.netcore.sharedframework.x86.2.1 | 2.1.29-servicing-30323-03.nupkg
vs.redist.common.netcore.sharedhost.x64.2.1 | 2.1.29-servicing-30323-02.nupkg
vs.redist.common.netcore.sharedhost.x64.2.1 | 2.1.29-servicing-30323-03.nupkg
vs.redist.common.netcore.sharedhost.x86.2.1 | 2.1.29-servicing-30323-02.nupkg
vs.redist.common.netcore.sharedhost.x86.2.1 | 2.1.29-servicing-30323-03.nupkg


[blob-runtime]: https://dotnetcli.blob.core.windows.net/dotnet/Runtime/
[blob-sdk]: https://dotnetcli.blob.core.windows.net/dotnet/Sdk/
[release-notes]: https://github.com/dotnet/core/blob/main/release-notes/2.1/2.1.29/2.1.29.md

[checksums-runtime]: https://dotnetcli.blob.core.windows.net/dotnet/checksums/2.1.29-sha.txt
[checksums-sdk]: https://dotnetcli.blob.core.windows.net/dotnet/checksums/2.1.29-sha.txt

[linux-install]: https://docs.microsoft.com/dotnet/core/install/linux
[linux-setup]: https://docs.microsoft.com/dotnet/core/install/
[dotnet-blog]:  https://devblogs.microsoft.com/dotnet/net-august-2021/


[//]: # ( Runtime 2.1.29)
[dotnet-runtime-linux-arm.tar.gz]: https://download.visualstudio.microsoft.com/download/pr/79a1a90b-2881-43af-96c4-4dadc5706db1/b3f3e9ff2b5449d860d87139d93888e3/dotnet-runtime-2.1.29-linux-arm.tar.gz
[dotnet-runtime-linux-arm64.tar.gz]: https://download.visualstudio.microsoft.com/download/pr/a2e4faad-ee1c-40ad-a620-db44d79cf4af/8e47522aa8c04f7e5764d2ce46e5b228/dotnet-runtime-2.1.29-linux-arm64.tar.gz
[dotnet-runtime-linux-musl-x64.tar.gz]: https://download.visualstudio.microsoft.com/download/pr/bd4dd6d0-3711-49b2-956e-2acb601a3307/b2b521d442b08ba49e794c0a6797d551/dotnet-runtime-2.1.29-linux-musl-x64.tar.gz
[dotnet-runtime-linux-x64.tar.gz]: https://download.visualstudio.microsoft.com/download/pr/4711027f-711a-4762-8892-6fe1e6082e31/40f6b6e973ace3f14d925e25074397a0/dotnet-runtime-2.1.29-linux-x64.tar.gz
[dotnet-runtime-osx-x64.pkg]: https://download.visualstudio.microsoft.com/download/pr/577af989-e3a2-4142-811b-42d657b47a93/affdcb04ac15dfddc3a3a183e8d7cc5e/dotnet-runtime-2.1.29-osx-x64.pkg
[dotnet-runtime-osx-x64.tar.gz]: https://download.visualstudio.microsoft.com/download/pr/b26ce75c-f004-4259-961b-eb4c29dd6fea/2bc156a4a2f01e32aa72c896fe5ff982/dotnet-runtime-2.1.29-osx-x64.tar.gz
[dotnet-runtime-win-arm.zip]: https://download.visualstudio.microsoft.com/download/pr/b1b2eac8-99ed-40ec-a53e-8d4832b216dc/6d00b927ddff39e0b1347e3861f6290c/dotnet-runtime-2.1.29-win-arm.zip
[dotnet-runtime-win-x64.exe]: https://download.visualstudio.microsoft.com/download/pr/c9e5b893-29fe-4323-92dc-e4c24fc83560/f0f5d1b6f1182dbc73ce05d5b080e73e/dotnet-runtime-2.1.29-win-x64.exe
[dotnet-runtime-win-x64.zip]: https://download.visualstudio.microsoft.com/download/pr/f734335a-5544-4a19-b4e7-a7e47a78fcb6/3ab636c8f92d32d3271902e3e3be7d41/dotnet-runtime-2.1.29-win-x64.zip
[dotnet-runtime-win-x86.exe]: https://download.visualstudio.microsoft.com/download/pr/64f2b136-6214-4230-b634-6aeaa55b971f/7dee9174cbc53a85760dfdf860f5d7e1/dotnet-runtime-2.1.29-win-x86.exe
[dotnet-runtime-win-x86.zip]: https://download.visualstudio.microsoft.com/download/pr/3760fcb8-e4e8-4fb3-85cc-63b9068896bd/8f5a75a625db09ef0be194677efe7a5d/dotnet-runtime-2.1.29-win-x86.zip

[//]: # ( ASP 2.1.29)
[aspnetcore-runtime-linux-arm.tar.gz]: https://download.visualstudio.microsoft.com/download/pr/f8aecd9f-8def-403a-b5d9-8b93644eccbf/e0eb92a0f1034c2999afda200a7319fd/aspnetcore-runtime-2.1.29-linux-arm.tar.gz
[aspnetcore-runtime-linux-musl-x64.tar.gz]: https://download.visualstudio.microsoft.com/download/pr/74692878-5518-4c11-9086-cd8b104cdca0/0cb1b776df2495f19bb8486240d7bbb9/aspnetcore-runtime-2.1.29-linux-musl-x64.tar.gz
[aspnetcore-runtime-linux-x64.tar.gz]: https://download.visualstudio.microsoft.com/download/pr/5d7cfd65-4f71-46e8-b05b-d7ff8d0daa00/0f21d9c66047f10d385ce15935116506/aspnetcore-runtime-2.1.29-linux-x64.tar.gz
[aspnetcore-runtime-osx-x64.tar.gz]: https://download.visualstudio.microsoft.com/download/pr/63e2b345-e838-445d-8eac-11612b4216d7/4eeb0750fdaa48591c8ef91a01fac049/aspnetcore-runtime-2.1.29-osx-x64.tar.gz
[aspnetcore-runtime-win-x64.exe]: https://download.visualstudio.microsoft.com/download/pr/ee15804c-341f-47a5-bdf8-216751c0830e/39bb732165910d1bd2cf9615b3c6acda/aspnetcore-runtime-2.1.29-win-x64.exe
[aspnetcore-runtime-win-x64.zip]: https://download.visualstudio.microsoft.com/download/pr/fb930e07-46de-473f-b69e-74f600b61d16/048aad79a806ac3ca6a3721920170d81/aspnetcore-runtime-2.1.29-win-x64.zip
[aspnetcore-runtime-win-x86.exe]: https://download.visualstudio.microsoft.com/download/pr/e8ffac0f-7236-4257-be2e-6ca8a2f1bb3c/d556ddabc2c98cdbf8e6dcacab3d0aa8/aspnetcore-runtime-2.1.29-win-x86.exe
[aspnetcore-runtime-win-x86.zip]: https://download.visualstudio.microsoft.com/download/pr/a7a76776-5197-447e-88ed-960ce4d82c48/dacd7091d0ef677b757f1455c7d88be9/aspnetcore-runtime-2.1.29-win-x86.zip
[dotnet-hosting-win.exe]: https://download.visualstudio.microsoft.com/download/pr/109ce9a7-02c8-4e3a-a59b-0314cb2ea404/83ec4ae63ecb192f72741bba8c783974/dotnet-hosting-2.1.29-win.exe

[//]: # ( SDK 2.1.817)
[dotnet-sdk-linux-arm.tar.gz]: https://download.visualstudio.microsoft.com/download/pr/4315bff0-490a-49fd-8147-851d8fa844c1/707d038c4783814a06de8133aeb468f4/dotnet-sdk-2.1.817-linux-arm.tar.gz
[dotnet-sdk-linux-arm64.tar.gz]: https://download.visualstudio.microsoft.com/download/pr/3e58ee72-24c8-4b98-86f9-145deb294ff2/b23cc58351162b38b0a839ca4e8efe00/dotnet-sdk-2.1.817-linux-arm64.tar.gz
[dotnet-sdk-linux-musl-x64.tar.gz]: https://download.visualstudio.microsoft.com/download/pr/f3dd8bc2-a343-40ac-ba53-ddadaf4a5b4b/88bc12759122ba1b92c25e538df3fccf/dotnet-sdk-2.1.817-linux-musl-x64.tar.gz
[dotnet-sdk-linux-x64.tar.gz]: https://download.visualstudio.microsoft.com/download/pr/fb3319a2-9b8b-47c5-bed8-22617fb0feb6/ffc365184f20e64f46ebe6d780c50049/dotnet-sdk-2.1.817-linux-x64.tar.gz
[dotnet-sdk-osx-x64.pkg]: https://download.visualstudio.microsoft.com/download/pr/c4346917-71b3-459b-9ca8-b7d39d8791ef/9fc059df54823c9a92aec90257fc0ecd/dotnet-sdk-2.1.817-osx-x64.pkg
[dotnet-sdk-osx-x64.tar.gz]: https://download.visualstudio.microsoft.com/download/pr/58d166e7-9ce9-4814-8a39-1a7bfb837db2/f848de26373885381d61adf98514c3e9/dotnet-sdk-2.1.817-osx-x64.tar.gz
[dotnet-sdk-win-x64.exe]: https://download.visualstudio.microsoft.com/download/pr/fa161251-fe8e-418d-ad24-8ef3ecdac1ce/a21b1aed1d651d16f04bcf3a543f8998/dotnet-sdk-2.1.817-win-x64.exe
[dotnet-sdk-win-x64.zip]: https://download.visualstudio.microsoft.com/download/pr/eec383bf-aabf-405e-bbe0-45f6bc3d0892/b8edd15297b21590df277f9f3207e8eb/dotnet-sdk-2.1.817-win-x64.zip
[dotnet-sdk-win-x86.exe]: https://download.visualstudio.microsoft.com/download/pr/015c1d4d-a7bd-451c-babd-c1e44d0a337d/d0af83c4dea6bda628dcd720a95bd727/dotnet-sdk-2.1.817-win-x86.exe
[dotnet-sdk-win-x86.zip]: https://download.visualstudio.microsoft.com/download/pr/effa3ab8-4411-44ae-81ca-ef39806afc57/037aae68c226f2b6bed319696b2491d4/dotnet-sdk-2.1.817-win-x86.zip
